import java.util.Arrays;
import java.util.Iterator;

import javax.swing.JButton;
import javax.swing.JFrame;

public class BoutonIterateur extends JButton {

	public static String BOUTON_ITERATEUR = "Bouton avec Iterateur";

	public BoutonIterateur(Iterator<?> it) {
		if (! it.hasNext()) 
			throw new IllegalArgumentException();
		setText(it.next().toString());
		addActionListener(e -> {
			System.out.println(this.getText());
			if (it.hasNext()) 
				this.setText(it.next().toString());
			else 
				System.exit(0);
		});
	}

	public static void main(String[] args) {
		javax.swing.SwingUtilities.invokeLater(new Runnable() {
			public void run() {
				Iterator<String> it = Arrays.asList("a", "z", "e", "r", "t", "y").iterator();
				JFrame f = new JFrame(BOUTON_ITERATEUR);
				JButton b = new BoutonIterateur(it);
				f.getContentPane().add(b);
				f.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
				f.pack();
				f.setLocationRelativeTo(null);
				f.setVisible(true);
			}
		});
	}
}
